/*
 * PM - 2016
 */

#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>

#define DELAY_SECVENTA		250
#define NUM_SECVENTE		6


void turn_on(int index) {

	PORTA |= (1 << index);
	_delay_ms(100);

}
void turn_off(int index) {

	PORTA &= ~(1 << index);
	_delay_ms(100);
}

void turn_off_all() { 
	int i; 
	for (i = 0; i < 6; i++) 
		PORTA &= ~(1 << i); 
}

void display_lights(int type) {

	int end = 0, i = 0, j = 0;


	while(end == 0) {

		switch(type) {
			
			case 0:
				i %= 6;

				if(i == 0) {
					turn_off_all();
					j++;
					if(j == 6) {
						end = 1;
					}
				}
				turn_on(i);

				i++; 
				break;

			case 1:
				i %= 6;
				if(i == 0) {
					turn_off_all();
					j++;
					if(j == 6) {
						end = 1;
					}
					turn_on(i);
				} else 
					if(i == 5) {
						turn_on(i);
						turn_off(i);
					} else {
						turn_on(i);
						turn_off(i - 1);
					}

				i++;
				break;

			case 2:
				i %= 11;
				
				if(i < 6){
					if(i == 0) {
						turn_off_all();
						j++;
						if(j == 6) {
							end = 1;
						}
						turn_on(i);
					} else {
						turn_on(i);
						turn_off(i - 1);
					}	
				}
				else{
					turn_on(11 - i - 1);
					turn_off(11 - i);
				} 
				i++;
				break;

			case 3:
				i %= 11;

				if (i == 0){
					turn_off(i);

					j++;
					if(j == 12){
						turn_off_all();
						end = 1;
					}
				}

				if (i < 6)
					turn_on(i);
				else
					turn_off(11 - i);

				i++;			
				break;

			case 4:
				i %= 6;
				if(i == 0) {
					j++;
					if(j == 6){
						turn_off_all();
						end = 1;
					}
					PORTA |= (1 << i);
					PORTA |= (1 << (5 - i));
					_delay_ms(40);

				} else {
					PORTA |= (1 << i);
					PORTA |= (1 << (5 - i));
					_delay_ms(40);

					PORTA &= ~(1 << (i - 1));
					PORTA &= ~(1 << (5 - i + 1));
					_delay_ms(40);

				}
		
				i++;
				break;

			case 5:
				i %= 3;
				if(i == 0){
					j++;
					if(j == 6){
						end = 1;
					}
				}
				PORTA = (PORTA << 1);
				_delay_ms(100);
				if(i == 0)
					PORTA |= 0x01;
					_delay_ms(100);
				i++;
				break;

			case 6:
				i %= 11;

				if(i == 0) {
					j++;
					if(j == 6)
						end = 1;
				}
				if (i < 6){
					turn_on(i);
					PORTA &= ~(1 << i);
				}
				else{
					turn_on(11 - i);
					PORTA &= ~(1 << (11 - i));					
				}
				i++;
				break;
		}	
	}
}

int main(void) {

	int type_count = 7;
	int type = 0;

	DDRA = 0xFF;

	while(1){
		display_lights(type);
		type++;

		if(type == type_count) 
			type = 0;
	}

	return 0;
}
